.envrc 8.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267
  1. # This is the .envrc for sentry, for use with direnv.
  2. # It's responsible for enforcing a standard dev environment by checking as much state as possible, and either performing
  3. # initialization (e.g. activating the venv) or giving recommendations on how to reach the desired state.
  4. # It also sets useful environment variables.
  5. # If you'd like to override or set any custom environment variables, this .envrc will read a .env file at the end.
  6. set -e
  7. # Upgrading Mac can uninstall the Command Line Tools, thus, removing our access to git
  8. # The message talks about xcrun, however, we can use the lack of git as a way to know that we need this
  9. # xcrun: error: invalid active developer path (/Library/Developer/CommandLineTools),
  10. # missing xcrun at: /Library/Developer/CommandLineTools/usr/bin/xcrun
  11. if [ "$(uname -s)" == "Darwin" ] && [ ! -f "/Library/Developer/CommandLineTools/usr/bin/git" ]; then
  12. echo -e "$(tput setaf 1)\nERROR: Complete the interactive installation (10+ mins) of the Command Line Tools.$(tput sgr0)"
  13. xcode-select --install
  14. return 1
  15. fi
  16. SENTRY_ROOT="$(
  17. cd "$(dirname "${BASH_SOURCE[0]}")"
  18. pwd -P
  19. )"
  20. source "${SENTRY_ROOT}/scripts/lib.sh"
  21. # XXX: we can't trap bash EXIT, because it'll override direnv's finalizing routines.
  22. # consequently, using "exit" anywhere will skip this notice from showing.
  23. # so need to use set -e, and return 1.
  24. trap notice ERR
  25. # This is used to group issues on Sentry.io.
  26. # If an issue does not call info() or die() it will be grouped under this
  27. error_message="Unknown issue"
  28. # This has to be the same value as what sentry-cli accepts
  29. log_level="info"
  30. help_message() {
  31. cat <<EOF
  32. For more help run: make direnv-help
  33. EOF
  34. }
  35. failure_message() {
  36. cat <<EOF
  37. ${red}${bold}direnv wasn't able to complete execution.
  38. You may have been given some recommendations in the error message.
  39. Follow them, and then you'll need to re-run direnv by running "direnv allow".${reset}
  40. EOF
  41. help_message
  42. }
  43. notice() {
  44. [ $? -eq 0 ] && return
  45. failure_message
  46. [ -z "${SENTRY_DEVENV_NO_REPORT+x}" ] && report_to_sentry
  47. }
  48. report_to_sentry() {
  49. if ! require sentry-cli; then
  50. curl -sL https://sentry.io/get-cli/ | bash
  51. fi
  52. # Report to sentry-dev-env project
  53. SENTRY_DSN="https://9bdb053cb8274ea69231834d1edeec4c@o1.ingest.sentry.io/5723503" \
  54. sentry-cli send-event -m "$error_message" --logfile "$_SENTRY_LOG_FILE" --level $log_level
  55. rm "$_SENTRY_LOG_FILE"
  56. }
  57. debug() {
  58. if [ "${SENTRY_DIRENV_DEBUG-}" ]; then
  59. echo -e "${@}"
  60. fi
  61. }
  62. info() {
  63. echo -e "${bold}${*}${reset}"
  64. }
  65. warn() {
  66. echo -e "${yellow}${*}${reset}" >&2
  67. log_level="warning"
  68. }
  69. die() {
  70. echo -e "${red}${bold}FATAL: ${*}${reset}" >&2
  71. # When reporting to Sentry, this will allow grouping the errors differently
  72. # NOTE: The first line of the output is used to group issues
  73. error_message=("${@}")
  74. log_level="error"
  75. return 1
  76. }
  77. prompt_python_venv_creation() {
  78. echo -e "${yellow}You are missing a Python virtualenv and we ${bold}need${reset}${yellow} to run a bootstrapping script (it can take a few minutes)"
  79. info "About to create ${venv_name}..."
  80. echo -e "\nContinue (y/N)?"
  81. read -r resp
  82. case "$resp" in
  83. y | Y) echo "Okay, let's do this." ;;
  84. *)
  85. die "Aborted!"
  86. ;;
  87. esac
  88. }
  89. show_commands_info() {
  90. echo -e "\n${red}Run the following commands to bring your environment up-to-date:"
  91. for cmd in "${commands_to_run[@]}"; do
  92. warn " ${red}$cmd"
  93. done
  94. echo ""
  95. }
  96. ### Environment ###
  97. commands_to_run=()
  98. # Always write stdout immediately. Very helpful for debugging
  99. export PYTHONUNBUFFERED=1
  100. # make sure we don't have any conflicting PYTHONPATH
  101. unset PYTHONPATH
  102. # don't check pypi for a potential new pip version; low-hanging fruit to save a bit of time
  103. export PIP_DISABLE_PIP_VERSION_CHECK=on
  104. # increase node's memory limit, required for our webpacking
  105. export NODE_OPTIONS=--max-old-space-size=4096
  106. # Frontend hot module reloader using `react-refresh`
  107. # Enable this by default for development envs (CI/deploys do not use envrc)
  108. export SENTRY_UI_HOT_RELOAD=1
  109. ### You can override the exported variables with a .env file
  110. # All exports should happen before here unless they're safeguarded (see devenv error reporting below)
  111. if [ -f "${SENTRY_ROOT}/.env" ]; then
  112. info "Loading variables from ${SENTRY_ROOT}/.env"
  113. dotenv "${SENTRY_ROOT}/.env"
  114. fi
  115. ## Notify of reporting to Sentry
  116. if [ -n "${SENTRY_DEVENV_NO_REPORT+x}" ]; then
  117. debug "No development environment errors will be reported (since you've defined SENTRY_DEVENV_NO_REPORT)."
  118. _SENTRY_LOG_FILE=''
  119. else
  120. # Since direnv traps the EXIT signal we place the temp file under /tmp for the odd time
  121. # the script will use the EXIT path
  122. _SENTRY_LOG_FILE=$(mktemp /tmp/sentry.envrc.$$.out || mktemp /tmp/sentry.envrc.XXXXXXXX.out)
  123. exec > >(tee "$_SENTRY_LOG_FILE")
  124. exec 2>&1
  125. debug "Development errors will be reported to Sentry.io. If you wish to opt-out, set SENTRY_DEVENV_NO_REPORT as an env variable."
  126. # This will allow `sentry devservices` errors to be reported
  127. export SENTRY_DEVSERVICES_DSN=https://23670f54c6254bfd9b7de106637808e9@o1.ingest.sentry.io/1492057
  128. fi
  129. # We can remove these lines in few months
  130. if [ "$SHELL" == "/bin/zsh" ]; then
  131. zshrc_path="${HOME}/.zshrc"
  132. header="# Apple M1 environment variables"
  133. if grep -qF "${header}" "${zshrc_path}"; then
  134. echo -e "\n${red}Please delete from ${zshrc_path}, the following three lines:${reset}"
  135. echo -e "${header}
  136. export CPATH=/opt/homebrew/Cellar/librdkafka/1.8.2/include
  137. export LDFLAGS=-L/opt/homebrew/Cellar/gettext/0.21/lib"
  138. echo -e "\nWe have moved exporting of these variables to the right place."
  139. return 1
  140. fi
  141. fi
  142. ### System ###
  143. for pkg in \
  144. make \
  145. docker \
  146. chromedriver \
  147. pkg-config \
  148. pyenv \
  149. openssl; do
  150. if ! require "$pkg"; then
  151. die "You seem to be missing the system dependency: ${pkg}
  152. Please install homebrew, and run brew bundle."
  153. fi
  154. done
  155. ### Git ###
  156. debug "Configuring git..."
  157. make setup-git-config
  158. ### Python ###
  159. if [ ! -x "${HOME}/.local/share/sentry-devenv/bin/devenv" ]; then
  160. # Old and busted.
  161. venv_name=".venv"
  162. if [ ! -f "${venv_name}/bin/activate" ]; then
  163. prompt_python_venv_creation
  164. # This is time consuming but it has to be done
  165. source "${SENTRY_ROOT}/scripts/bootstrap-py3-venv"
  166. fi
  167. else
  168. # The new hotness (coming soon).
  169. venv_name="${HOME}/.local/share/sentry-devenv/virtualenvs/sentry"
  170. if [ ! -f "${venv_name}/bin/activate" ]; then
  171. devenv sync
  172. fi
  173. fi
  174. # The user might be cd'ing into sentry with another non-direnv managed
  175. # (in that it would be automatically deactivated) virtualenv active.
  176. deactivate 2>/dev/null || true
  177. # shellcheck disable=SC1091
  178. source "${venv_name}/bin/activate"
  179. # XXX: ideally, direnv is able to export PS1 as modified by sourcing venvs
  180. # but we'd have to patch direnv, and ".venv" isn't descriptive anyways
  181. unset PS1
  182. debug "Ensuring proper virtualenv..."
  183. "${SENTRY_ROOT}/scripts/ensure-venv.sh"
  184. if ! require sentry; then
  185. warn "Your virtualenv is activated, but sentry doesn't seem to be installed."
  186. commands_to_run+=("make install-py-dev")
  187. fi
  188. ### pre-commit ###
  189. debug "Checking pre-commit..."
  190. if ! require pre-commit; then
  191. warn "Looks like you don't have pre-commit installed."
  192. commands_to_run+=("make setup-git")
  193. fi
  194. python3 -m tools.docker_memory_check
  195. ### Node ###
  196. debug "Checking node..."
  197. if ! require node; then
  198. die "You don't seem to have node installed. Install volta (a node version manager): https://develop.sentry.dev/environment/#javascript"
  199. fi
  200. make node-version-check
  201. if [ ! -x "node_modules/.bin/webpack" ]; then
  202. warn "You don't seem to have yarn packages installed."
  203. commands_to_run+=("make install-js-dev")
  204. fi
  205. PATH_add node_modules/.bin
  206. # These are commands that can take a significant amount of time
  207. if [ ${#commands_to_run[@]} -ne 0 ]; then
  208. show_commands_info
  209. fi
  210. if [ "${log_level}" != "info" ]; then
  211. help_message
  212. warn "\nPartial success. The virtualenv is active, however, you're not fully up-to-date (see messages above)."
  213. else
  214. echo "${green}${bold}SUCCESS!${reset}"
  215. fi
  216. # Since we can't use an EXIT routine we need to guarantee we delete the file here
  217. [ -z "$_SENTRY_LOG_FILE" ] || rm -f "$_SENTRY_LOG_FILE"